P10111 [GESP202312 七级] 纸牌游戏 题解
![P10111 [GESP202312 七级] 纸牌游戏 题解](/_astro/P10111.BkbvG2PK_ZkDHJR.webp)
624 字
3 分钟
P10111 [GESP202312 七级] 纸牌游戏 题解
看标签知道要用 DP。
于是开始分析。
状态: 前 轮中,第 轮出 ,一共换了 次牌的最大钱数。很好理解。
转移也不难,不就是不换和换两种吗!
所以,转移就是: 其中, 表示你要换的牌,显然要求 , 表示你出牌 ,小杨出 时的胜负情况。胜返回 ,负返回 ,平返回 。上面就是不还,下面就是换。
观察发现,获胜时要么大 ,要么小 (因为此处“”)。
所以 函数如下:
int pk(int x, int y) { if (x == y) return 1; if (x == y + 1 || x == y - 2) return 2; return 0;}以上为朴素做法。还能不能优化呢?滚动数组嘛!这玩意儿不就是专门给其中一维是“前 回……”的 DP 状态砍掉这维的嘛!
于是用上滚动数组(这个不会的去看背包),空间复杂度就可以降到 啦!
用上滚动数组的:
// Problem: P10111 [GESP202312 七级] 纸牌游戏// Contest: Luogu// URL: https://www.luogu.com.cn/problem/P10111// Memory Limit: 512 MB// Time Limit: 1000 ms//// Powered by CP Editor (https://cpeditor.org)
/*Code by Block_Fish*/#include <bits/stdc++.h>
#define log printf#define EPS 1e-8#define INF 0x3f3f3f3f#define FOR(i, l, r) for (int(i) = (l); (i) <= (r); ++(i))#define IOS \ ios::sync_with_stdio(false); \ cin.tie(nullptr); \ cout.tie(nullptr);
using namespace std;
typedef __int128 i128;typedef long long ll;typedef pair<int, int> PII;
const int N = 1010;int n, a[N], b[N], c[N], dp[3][N], ans = -INF;
template <typename T>
inline T read() { T sum = 0, fl = 1; char ch = getchar(); for (; !isdigit(ch); ch = getchar()) if (ch == '-') fl = -1; for (; isdigit(ch); ch = getchar()) sum = sum * 10 + ch - '0'; return sum * fl;}
template <typename T>
inline void write(T x) { if (x < 0) putchar('-'), write<T>(-x); static T sta[35]; int top = 0; do { sta[top++] = x % 10, x /= 10; } while (x); while (top) putchar(sta[--top] + 48);}
int pk(int x, int y) { if (x == y) return 1; if (x == y + 1 || x == y - 2) return 2; return 0;}
int main() { n = read<int>(); FOR(i, 1, n) a[i] = read<int>(); FOR(i, 1, n - 1) b[i] = read<int>(); FOR(i, 1, n) c[i] = read<int>(); memset(dp, -0x3f, sizeof(dp)); FOR(i, 0, 2) dp[i][0] = pk(i, c[1]) * a[1]; FOR(i, 2, n) for (int j = i - 1; j >= 0; --j) FOR(k, 0, 2) { int s = pk(k, c[i]) * a[i]; dp[k][j] += s; // 默认不换 if (j > 0) // 防止越界 FOR(l, 0, 2) // 换,换成 l dp[k][j] = max(dp[k][j], dp[l][j - 1] + s - b[j]); } FOR(i, 0, n - 1) FOR(j, 0, 2) ans = max(ans, dp[j][i]); log("%d", ans); return 0;}支持与分享
如果这篇文章对你有帮助,欢迎分享给更多人或打赏支持!
P10111 [GESP202312 七级] 纸牌游戏 题解
https://www.leo2011.eu.org/posts/luogu-p10111/相关文章智能推荐
1
题解:P11248 [GESP202409 七级] 矩阵移动
题解讲解了如何用 DP 解决 GESP 2024 年 9 月的七级题目「矩阵移动」。
2
题解:P15290 [MCO 2023] Two Pointers (easy version)
题解讲解了如何解决洛谷 P15290。
3
B3929 [GESP202312 五级] 小杨的幸运数 题解
题解洛谷 B3929 3929 [GESP202312 五级] 小杨的幸运数的题解。来自考场二分思路。
4
题解:P9704 「TFOI R1」Tree Home
题解带有完整推公式过程的洛谷 P9704 「TFOI R1」Tree Home 一题题解,使用 ST 表。
5
【附 Hack 数据及原理】 题解:P1195 口袋的天空
题解洛谷 P1195 的题解。积木鱼 作为传奇击杀王曾利用 5 组数据 Hack 本题 22 篇题解,这里给出两种能通过目前全部数据且时间复杂度正确的做法。
随机文章随机推荐













